( FROM ROSETTA CODE )

( https://rosettacode.org/wiki/Sieve_of_Eratosthenes#Forth )

: PRIME? ( N -- ? )
  HERE + C@ 0= ;

: COMPOSITE! ( N -- )
  HERE + 1 SWAP C! ;

: 2DUP OVER OVER ; 

: SHOWPRIMES
  ." PRIMES: "
  2 DO I PRIME?
    IF I . ENDIF
  LOOP ;

: COUNTPRIMES
  ." PRIME COUNT: "
  0 SWAP
  2 DO I PRIME?
    IF 1+ ENDIF
  LOOP
  . ;

-->






: SIEVE ( N -- )
  HERE OVER ERASE
  2
  BEGIN
    2DUP DUP * >
  WHILE
    DUP PRIME? IF
      2DUP DUP * DO
        I COMPOSITE!
      DUP +LOOP
    ENDIF
    1+
  REPEAT
  DROP
  ;
-->
( SIEVE DEFINED. )

( EDIT SIEVE COUNT TO DO MORE )

( SIEVE IS KEPT IN THE )
( FREE RAM AREA, )
( WITH THE EXPECT-ED )
( CONSEQUENCES. )

( MAY MISBEHAVE )
( IF RUN TWICE IN A ROW )
( WITHOUT REPEAL-ING BACK. )


( OKAY UP TO AT LEAST 8192. )
100     SIEVE

DUP 

SHOWPRIMES

COUNTPRIMES

( 8192: 6 SECONDS TO FIND PRIMES )
( 3 SECONDS TO COUNT )
( XROAR NORMAL )

